#property copyright "chinaski"
#property version   "1.00"
#property strict




static int __object_counter=0;
bool delete_me=false;

int   price2y(double price,datetime       time=0,long chart_id=0,int sub_window=0)
{
   int y=0;
   int x=0;
   if(time <= 0)
      time=TimeCurrent();
   if(ChartTimePriceToXY(chart_id,sub_window,TimeCurrent(),price,x,y) == false)
   {
      PrintFormat("error: %s %d",__FUNCTION__,GetLastError());
   }
   return y;
}

//----------------------------
//--mybutton
//----------------------------
class mybutton 
{
public:
   mybutton(     const string            text="Button",            // text 
                  const int               x=0,                      // X coordinate 
                  const int               y=0,                      // Y coordinate 
                  const int               width=50,                 // button width 
                  const int               height=18,                // button height                   
                  const color             clr=clrBlack,             // text color 
                  const color             back_clr=C'236,233,216',  // background color 
                  const string            xfont="Arial",             // font 
                  const int               font_size=10,             // font size 
                  const color             border_clr=clrNONE,       // border color 
                  const int               sub_window=0,             // subwindow index 
                  const long              chart_ID=0,               // chart's ID 
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // chart corner for anchoring                   
                  const bool              state=false,              // pressed/released 
                  const bool              back=false,               // in the background 
                  const bool              selection=false,          // highlight to move 
                  const bool              hidden=true,              // hidden in the object list 
                  const long              z_order=1,                             // priority for mouse click 
                  bool                    redraw=false)  
  { 
   _ignore=state();
   _locked_state=false;
   _clicked=false;
   ++__object_counter;
//--- reset the error value 
     ResetLastError(); 
     _name=StringFormat("OBJ_BUTTON_%d_%d",__object_counter,TimeCurrent());    
//--- create the button 
     if(!ObjectCreate(chart_ID,_name,OBJ_BUTTON,sub_window,0,0)) 
     { 
        PrintFormat("Failed to create the button %s Error code = %d ",_name,GetLastError()); 
     }
     else
     {
         
         _chartid=chart_ID;      
         //--- set button coordinates 
         ObjectSetInteger(_chartid,_name,OBJPROP_XDISTANCE,x); 
         ObjectSetInteger(_chartid,_name,OBJPROP_YDISTANCE,y); 
         //--- set button size 
         ObjectSetInteger(_chartid,_name,OBJPROP_XSIZE,width); 
         ObjectSetInteger(_chartid,_name,OBJPROP_YSIZE,height); 
         //--- set the chart's corner, relative to which point coordinates are defined 
         ObjectSetInteger(_chartid,_name,OBJPROP_CORNER,corner); 
         //--- set the text 
         ObjectSetString(_chartid,_name,OBJPROP_TEXT,text); 
         //--- set text font 
         ObjectSetString(_chartid,_name,OBJPROP_FONT,xfont); 
         //--- set font size 
         ObjectSetInteger(_chartid,_name,OBJPROP_FONTSIZE,font_size); 
         //--- set text color 
         ObjectSetInteger(_chartid,_name,OBJPROP_COLOR,clr); 
         //--- set background color 
         ObjectSetInteger(_chartid,_name,OBJPROP_BGCOLOR,back_clr); 
         //--- set border color 
         ObjectSetInteger(_chartid,_name,OBJPROP_BORDER_COLOR,border_clr); 
         //--- display in the foreground (false) or background (true) 
         ObjectSetInteger(_chartid,_name,OBJPROP_BACK,back); 
         //--- set button state 
         ObjectSetInteger(_chartid,_name,OBJPROP_STATE,state); 
         //--- enable (true) or disable (false) the mode of moving the button by mouse 
         ObjectSetInteger(_chartid,_name,OBJPROP_SELECTABLE,selection); 
         ObjectSetInteger(_chartid,_name,OBJPROP_SELECTED,selection); 
         //--- hide (true) or display (false) graphical object name in the object list 
         ObjectSetInteger(_chartid,_name,OBJPROP_HIDDEN,hidden); 
         //--- set the priority for receiving the event of a mouse click in the chart 
         ObjectSetInteger(_chartid,_name,OBJPROP_ZORDER,z_order); 
         //--- successful execution 
         
         if(redraw == true)
            ChartRedraw();         
       
     }
  } 
   virtual ~mybutton()
   {
      if(StringLen(_name) > 0)
      {
         ResetLastError();
         if(ObjectDelete(_chartid,_name) == false)
         {
            PrintFormat("Object %s deletion error. code=%d",_name,GetLastError());
         }
         else
         {
           // PrintFormat("Object <%s> deleted",_name);
         }
         _name="";
      }

   }  
public:
   
   string   text(void) const {return ObjectGetString(_chartid,_name,OBJPROP_TEXT);}
   bool     text(string x,bool redraw=true) 
   {
      bool bres=ObjectSetString(_chartid,_name,OBJPROP_TEXT,x);
      if(redraw == true)
         ChartRedraw();
      return bres;     
   }
    
    
   bool     state(void) const {return (bool) ObjectGetInteger(_chartid,_name,OBJPROP_STATE);}
   void     state(bool bpressed, bool chart_update=false)  
   {
      ObjectSetInteger(_chartid,_name,OBJPROP_STATE,(int) bpressed); 
      _locked_state=bpressed;
      if(chart_update == true)
         ChartRedraw();
   }
   bool  point_in_object(int ptx,int pty)
   {
      long x=ObjectGetInteger(_chartid, _name,OBJPROP_XDISTANCE);
      long y=ObjectGetInteger(_chartid, _name,OBJPROP_YDISTANCE);
      
      long w=ObjectGetInteger(_chartid, _name,OBJPROP_XSIZE);
      long h=ObjectGetInteger(_chartid, _name,OBJPROP_YSIZE);

      if(   ptx < x       // left out
         || ptx > (x+w)   // right out
         || pty < y       // top out
         || pty > (y+h)       // bottom out
         )
            return false;
      return true;
   }
   
   // false: chart event does not affect this
   virtual bool OnChartEvent(int id,long lp,double dp,string sp)   
   {
     // if(ObjectGetInteger(_chartid,_name,OBJPROP_READONLY,0) <= 0)
     //    return false;
         
   
      if(id==CHARTEVENT_OBJECT_CLICK && sp == _name)
      // called when release left mouse button
      {
            state(false);  
         _clicked=false;
         _locked_state = state();
         _ignore = false;
         
         return true;
      }  
      else if(id==CHARTEVENT_MOUSE_MOVE && point_in_object((int)lp,(int)dp) == true && sp == "1")
      {
         if(!_ignore)
         {
            _clicked=true;
            _ignore = true;
            state(!state());     
         }
         return true;
      }
      // mouse outside
      else if(id==CHARTEVENT_MOUSE_MOVE && point_in_object((int)lp,(int)dp) == false)
      {
         if(state() != _locked_state)
         {
            state(_locked_state);
            _ignore = false;
         }
      } 
   
      return false;
   }
public:
   bool  clicked(bool reset=true)
   {
      bool x=_clicked;
      if(x == true)
      {
         if(reset==true)
            _clicked=false;
      }
      return x;
   }   
   
protected:
   bool           _ignore;
   bool           _locked_state;
   bool           _clicked;   
   string         _name;
   long           _chartid;
};


//----------------------------
//--myhline
//----------------------------
class myhline 
{
public:
     myhline(    double                price=0,           // line price 
                    const color           clr=clrRed,        // line color 
                    string                tooltip="",
                    const ENUM_LINE_STYLE style=STYLE_SOLID, // line style 
                    const int             width=1,           // line width 
                    const bool            back=false,        // in the background 
                    const bool            selection=true,    // highlight to move                  
                    const bool            hidden=true,       // hidden in the object list 
                    const long            chart_ID=0,        // chart's ID 
                    const int             sub_window=0,      // subwindow index 
                    const long            z_order=0,
                    bool redraw=false)       
     { 
   //--- if the price is not set, set it at the current Bid price level 
      if(!price) 
         price=SymbolInfoDouble(Symbol(),SYMBOL_BID); 
      //--- reset the error value 
      ResetLastError(); 
      //--- create a horizontal line 
      ++__object_counter;
      //_name=(StringLen(tooltip) == 0 ? StringFormat("hl_%d",__object_counter) : tooltip);  
      _name=StringFormat("OBJ_HLINE_%d_%d",__object_counter,TimeCurrent());  
      _chartid=chart_ID;     
      //--- create the button 
      if(!ObjectCreate(_chartid,_name,OBJ_HLINE,sub_window,0,price)) 
      { 
         PrintFormat("Failed to create the hline %s Error code = %d",_name,GetLastError()); 
         
      }
      else
      {
         ObjectSetString(_chartid,_name,OBJPROP_TOOLTIP,tooltip);       
         //--- set line color 
         ObjectSetInteger(_chartid,_name,OBJPROP_COLOR,clr); 
         //--- set line display style 
         ObjectSetInteger(_chartid,_name,OBJPROP_STYLE,style); 
         //--- set line width 
         ObjectSetInteger(_chartid,_name,OBJPROP_WIDTH,width); 
         //--- display in the foreground (false) or background (true) 
         ObjectSetInteger(_chartid,_name,OBJPROP_BACK,back); 
         //--- enable (true) or disable (false) the mode of moving the line by mouse 
         //--- when creating a graphical object using ObjectCreate function, the object cannot be 
         //--- highlighted and moved by default. Inside this method, selection parameter 
         //--- is true by default making it possible to highlight and move the object 
         ObjectSetInteger(_chartid,_name,OBJPROP_SELECTABLE,selection); 
         ObjectSetInteger(_chartid,_name,OBJPROP_SELECTED,selection); 
         //--- hide (true) or display (false) graphical object name in the object list 
         ObjectSetInteger(_chartid,_name,OBJPROP_HIDDEN,hidden); 
         //--- set the priority for receiving the event of a mouse click in the chart 
         ObjectSetInteger(_chartid,_name,OBJPROP_ZORDER,z_order); 
         //--- successful _chartid 
      }   
   } 
   virtual ~myhline()
   {
      if(StringLen(_name) > 0)
      {
         ResetLastError();
         if(ObjectDelete(_chartid,_name) == false)
         {
            PrintFormat("Object %s deletion error. code=%d",_name,GetLastError());
         }
         else
         {
           // PrintFormat("Object %s deleted",_name);
         }
         _name="";
      }

   }
    
   
protected:
  // double _price;
   long     _chartid;   
   string   _name;
};

//!
//! my_button_line
//!
class my_button_line
{
public:
   my_button_line(double price=0.0)
   {
         if(price <= 0.0)
            price=Ask;
         
         // create   hline
         int pixels=2;         
         _myhline=new myhline(price,clrAquamarine,"tooltip",STYLE_SOLID,pixels,true);
               
         int y=price2y(price,0,0,0);
         
         // create button
         int size=20; // #problem (change to e.g to 40 or greater in order to remove problem)
         _mybutton=new mybutton("x",1,y+1,size,size,clrBlack,clrWheat);
         
         ChartRedraw(0);
                    
   }
   virtual ~my_button_line()
   {
      cleanup();
   }
   
public:
   void  cleanup(void)
   {
      if(_myhline != NULL)
      {
         delete _myhline;
         _myhline=NULL;
      }
      if(_mybutton != NULL)
      {
         delete _mybutton;
         _mybutton=NULL;
      }
      ChartRedraw();
   } 
   bool valid(void) const
   {
      if(_myhline != NULL && _mybutton != NULL)
         return true;
      return false;
   }
public:   
   void OnChartEvent(const int id,
                     const long &lparam,
                     const double &dparam,
                     const string &sparam)
   {
         if(_mybutton != NULL && _mybutton.OnChartEvent(id,lparam,dparam,sparam) == true)
         {
           // PrintFormat("Button event=%d",id);
              delete_me=true;
         }
   }   
protected:
   myhline*    _myhline;
   mybutton*   _mybutton;
};


my_button_line*   _my_button_line=NULL;
int point_count=0;
//+------------------------------------------------------------------+
int OnInit()
{
   ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,1);
   EventSetMillisecondTimer(50);
   _my_button_line=new my_button_line;
   
   return 0;
}
void OnDeinit(const int reason)
{
   if(_my_button_line != NULL)
   {
      delete _my_button_line;
      _my_button_line=NULL;
   }
  
}
//+------------------------------------------------------------------+
void OnTimer()
{
   if(_my_button_line != NULL)
   {
      if(_my_button_line.valid() == true)
      {
         if(delete_me == true)
         {
            delete _my_button_line;//_my_button_line.cleanup();
            _my_button_line=NULL;
         }
      }
   }
   else
   {
      _my_button_line=new my_button_line;
      delete_me=false;
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
     if(_my_button_line != NULL)
         _my_button_line.OnChartEvent(id,lparam,dparam,sparam);
         
}
//+------------------------------------------------------------------+